const { ipcRenderer } = require('electron');
let tables_data;

function openFile(file_name) {
	$.ajax({
		dataType: "json",
		url: file_name,
		cache: false,
		success: (json, textStatus, jqXHR) => {
			tables_data = json;
			refreshPage();
		}
	});
}

function clearPage() {
	$("#tables").empty();
	$("nav").empty();
	// TODO clear the input values in the details panel
}

function refreshPage() {
	clearPage();
	generateTables();
	showTab(tables_data[0]["id"]+"-tab");
}

function generateTables() {
	for (let table_data of tables_data) {
		const table_id = table_data["id"];
		let a = $("<a></a>")
			.attr("id", table_id+"-nav")
			.addClass("nav-link")
			.attr("href", "#"+table_id)
			.text(table_data["name"])
			.on("click", () => {
				showTab(table_id+"-tab");
			});
		$("nav").append(a);

		let table_div = $("<div></div>")
			.attr("id", table_id+"-tab")
			.addClass("tab-pane table-responsive");

		let table = $("<table></table>")
			.attr("id", table_id)
			.addClass("table table-bordered")
			.append($("<thead></thead>")
				.append($("<tr></tr>")
					.addClass("text-nowrap")))
			.append("<tbody>");

		for (let i=0; i < table_data["col-def"].length; i++) {
			const col_id = table_data["col-def"][i]["field"];
			table.find("thead > tr")
				.append($("<th>")
					.attr("id", table_id+"-"+col_id)
					.text(table_data["col-def"][i]["title"]));
		}

		for (let i=0; i < table_data["rows"].length; i++) {
			const row = table_data["rows"][i];
			const row_id = row["uid"];
			let tr = $("<tr></tr>")
				.attr("id", table_id+"-"+row_id);
			for (let j=0; j < table_data["col-def"].length; j++) {
				const col = table_data["col-def"][j];
				const col_id = col["field"];
				let td = $("<td></td>")
					.attr("id", table_id+"-"+col_id+"-"+row_id)
					.text(row[col_id]);
				tr.append(td);
			}
			table.find("tbody").append(tr);
		}

		table_div.append(table)
		$("#tables").append(table_div);
	}
}

function showTab(tab_name) {
	$("#tables").children().removeClass("show active");
	$("nav").children().removeClass("active");
	$("#"+tab_name).addClass("show active");
	$("#"+tab_name.replace("-tab", "-nav")).addClass("active");
}

ipcRenderer.on("open-default", (event) => {
	openFile("default.json");
})
